/* Mixmaster version 3  --  (C) 1999 Anonymizer Inc.

   Mixmaster may be redistributed and modified under certain conditions.
   This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
   ANY KIND, either express or implied. See the file COPYRIGHT for
   details.

   Menu-based user interface -- send message
   $Id: menusend.c,v 1.38 1999/05/14 15:05:20 um Exp $ */


#include "menu.h"
#include "mix3.h"
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#ifdef POSIX
#include <unistd.h>
#else
#include <io.h>
#endif

void send_message(int type, char *nym, BUFFER *in)
{
  char dest[LINELEN] = "", subject[LINELEN] = "";
  char chain[CHAINMAX], thisnym[LINELEN], path[PATHMAX];
  BUFFER *chainlist, *msg, *txt, *tmp, *tmp2, *field, *content, *cc, *cite;
  int numcopies;
  int hdr = 0;			/* txt buffer contains header lines */
  int encoded = 0;
  FILE *f;
  int n, err;

#ifdef USE_PGP
  int sign = 0, encrypt = 0, key = 0;

#endif
#ifdef USE_NCURSES
  int c;
  char line[LINELEN];

#endif
  msg = buf_new();
  tmp = buf_new();
  tmp2 = buf_new();
  txt = buf_new();
  field = buf_new();
  content = buf_new();
  chainlist = buf_new();
  cc = buf_new();
  cite = buf_new();
  strncpy(chain, CHAIN, CHAINMAX);
  numcopies = NUMCOPIES;

  mix_status("");
  strncpy(thisnym, nym, sizeof(thisnym));

  if (in != NULL)
    buf_set(txt, in);

  if (txt->length && strileft(txt->data, "From "))
    buf_getline(txt, field);	/* ignore envelope From */

  if (type == 'p' || type == 'm') {
#ifndef USE_NCURSES
    mix_status("Invalid option to -f");
    mix_exit();
    exit(1);
#else
    clear();
    echo();
    if (in != NULL)
      mvprintw(1, 0, "%s forwarding message...", thisnym);
    if (type == 'p')
      mvprintw(3, 0, "Newsgroups: ");
    else
      mvprintw(3, 0, "Send message to: ");
    refresh();
    wgetnstr(stdscr, dest, LINELEN);
    if (dest[0] == '\0') {
      noecho();
      cl(3, 0);
      goto quit;
    }
    if (txt->length == 0) {
      mvprintw(4, 0, "Subject: ");
      refresh();
      wgetnstr(stdscr, subject, LINELEN);
    } else {
      strcpy(subject, "Forwarded message");
      while (buf_getheader(txt, field, content) == 0) {
	if (content->length)
	  decode_header(content);
	encoded = encoding(encoded, field, content);
	if (strieq(field->data, "subject")) {
	  strncpy(subject, content->data, sizeof(subject));
	  strncat(subject, " (fwd)", sizeof(subject));
	}
	if (strieq(field->data, "from") ||
	    strieq(field->data, "subject") ||
	    strieq(field->data, "date")) {
	  buf_cat(tmp, field);
	  buf_appends(tmp, ": ");
	  buf_cat(tmp, content);
	  buf_nl(tmp);
	}
      }
      buf_nl(tmp);
      if (encoded)
	txtdecode(tmp, txt);
      else
	buf_rest(tmp, txt);
      buf_set(txt, tmp);
    }
    noecho();
#endif
  } else {
    strcpy(subject, "Re: your mail");
    while (buf_getheader(txt, field, content) == 0) {
      decode_header(content);
      encoded = encoding(encoded, field, content);
      if (strieq(field->data, "subject")) {
	if (strleft(content->data, "Re: "))
	  subject[0] = '\0';
	else
	  strcpy(subject, "Re: ");
	strncat(subject, content->data, sizeof(subject));
      }
      if (strieq(field->data, "from"))
	buf_set(cite, content);
      if (type == 'p' || type == 'f') {
	if (dest[0] == '\0' && strieq(field->data, "newsgroups"))
	  strncpy(dest, content->data, sizeof(dest));
	if (strieq(field->data, "followup-to") &&
	    !strieq(content->data, "poster"))
	  strncpy(dest, content->data, sizeof(dest));
	if (strieq(field->data, "message-id")) {
	  buf_appends(tmp, "References: ");
	  buf_cat(tmp, content);
	  buf_nl(tmp);
	}
      } else {
	if (dest[0] == '\0' && strieq(field->data, "from"))
	  strncpy(dest, content->data, sizeof(dest));
	if (strieq(field->data, "reply-to"))
	  strncpy(dest, content->data, sizeof(dest));
	if (type == 'g' && (strieq(field->data, "to") ||
			    strieq(field->data, "cc"))) {
	  if (cc->length)
	    buf_appends(cc, ", ");
	  buf_cat(cc, content);
	}
	if (strieq(field->data, "message-id")) {
	  buf_appends(tmp, "In-Reply-To: ");
	  buf_cat(tmp, content);
	  buf_nl(tmp);
	}
      }
    }
    if (cc->length) {
      buf_appends(tmp, "Cc: ");
      buf_cat(tmp, cc);
      buf_nl(tmp);
    }
    if (tmp->length > 0)
      hdr = 1;
    if (hdr)
      buf_nl(tmp);

    if ((type == 'f' || type == 'g') && cite->length) {
      buf_cat(tmp, cite);
      buf_appends(tmp, " wrote:\n\n");
    }
    if (type == 'r')
      buf_appends(tmp, "You wrote:\n\n");

    if (encoded)
      txtdecode(tmp2, txt);
    else
      buf_rest(tmp2, txt);

    while (buf_getline(tmp2, content) != -1) {
      buf_appends(tmp, "> ");
      buf_cat(tmp, content);
      buf_nl(tmp);
    }
    buf_set(txt, tmp);
    if (dest[0] == '\0') {
#ifdef USE_NCURSES
      beep();
      mix_status("No recipient address found.");
#endif
      goto quit;
    }
    goto edit;
  }

#ifdef USE_NCURSES
redraw:
  clear();

  for (;;) {
    standout();
    mvprintw(0, 0, "Mixmaster %s - ", VERSION);
    printw(type == 'p' || type == 'f' ? "posting to Usenet" : "sending mail");
    standend();
    mix_status(NULL);
    cl(2, 0);
    printw("n)ym: %s", thisnym);
    if (!strleft(thisnym, NONANON)) {
      cl(4, 0);
      printw("c)hain: %s", chain);
      cl(5, 0);
      printw("r)edundancy: %3d copies ", numcopies);
    }
    cl(7, 0);
    printw("d)estination: %s", dest);
    cl(8, 0);
    printw("s)ubject: %s", subject);
#ifdef USE_PGP
    if (type != 'p' && type != 'f') {
      cl(10, 0);
      printw("pgp encry)ption: ");
      if (encrypt)
	printw("yes");
      else
	printw("no");
    }
    if (!streq(thisnym, ANON)) {
      cl(11, 0);
      printw("p)gp signature: ");
      if (sign)
	printw("yes");
      else
	printw("no");
      cl(12, 0);
      printw("attach pgp k)ey: ");
      if (key)
	printw("yes");
      else
	printw("no");
    }
#endif

    if (txt->length == 0)
      mvprintw(LINES - 3, 20,
	       "e)dit message        f)ile                q)uit");
    else
      mvprintw(LINES - 3, 20,
	       "m)ail message        e)dit message        q)uit");
    move(LINES - 1, COLS - 1);
    refresh();
    c = getch();
    if (c != ERR) {
      mix_status("");
      if (c == '\r' || c == '\n') {	/* default action is edit or mail */
	if (txt->length == 0)
	  c = 'e';
	else
	  c = 'm';
      }
      switch (c) {
      case 'n':
	menu_nym(thisnym);
	goto redraw;
      case '\014':
	goto redraw;
      case 'd':
	echo();
	cl(LINES - 3, 20);
	cl(7, 14);
	wgetnstr(stdscr, dest, LINELEN);
	noecho();
	break;
      case 's':
	echo();
	cl(LINES - 3, 20);
	cl(8, 10);
	wgetnstr(stdscr, subject, LINELEN);
	noecho();
	break;
      case 'c':
	menu_chain(chain, 0, (type == 'p' || type == 'f')
		   && streq(thisnym, ANON));
	goto redraw;
      case 'r':
	echo();
	cl(LINES - 5, 20);
	cl(5, 13);
	wgetnstr(stdscr, line, LINELEN);
	numcopies = strtol(line, NULL, 10);
	if (numcopies < 1 || numcopies > 10)
	  numcopies = 1;
	noecho();
	break;
      case 'f':
	cl(LINES - 3, 0);
	askfilename(path);
	cl(LINES - 3, 0);
	if ((f = fopen(path, "r")) != NULL) {
	  buf_clear(txt);
	  buf_read(txt, f);
	  fclose(f);
	} else
	  beep();
	break;
      case 'e':
#endif
	{
	  char s[PATHMAX];
	  char *editor;

	edit:
	  sprintf(path, "%s/x%02x%02x%02x%02x.txt", POOLDIR,
		  rnd_byte(), rnd_byte(), rnd_byte(), rnd_byte());
	  if (txt->length > 0) {
	    f = fopen(path, "w");
	    if (f == NULL) {
#ifdef USE_NCURSES
	      beep();
#endif
	    } else {
	      if (type != 'm' && type != 'p') {
		if (type == 'f')
		  fprintf(f, "Newsgroups: %s\n", dest);
		if (type == 'r' || type == 'g')
		  fprintf(f, "To: %s\n", dest);
		fprintf(f, "Subject: %s\n", subject);
		if (!hdr)
		  fprintf(f, "\n");
	      }
	      buf_write(txt, f);
	      fclose(f);
	    }
	  }
	  editor = getenv("EDITOR");
	  if (editor == NULL)
	    editor = "vi";
	  strncpy(s, editor, PATHMAX);
	  strncat(s, " ", PATHMAX);
	  strncat(s, path, PATHMAX);

#ifdef USE_NCURSES
	  clear();
	  refresh();
	  endwin();
#endif
	  system(s);
#ifdef USE_NCURSES
	  refresh();
#endif

	  f = fopen(path, "r");
	  if (f == NULL) {
#ifdef USE_NCURSES
	    clear();
	    beep();
	    continue;
#else
	    goto quit;
#endif
	  }
	  buf_reset(txt);
	  hdr = 0;
	  if (type == 'r' || type == 'g' || type == 'f') {
	    buf_reset(tmp);
	    buf_read(tmp, f);
	    while (buf_getheader(tmp, field, content) == 0) {
	      if (strieq(field->data, "subject"))
		strncpy(subject, content->data,
			sizeof(subject));
	      else if ((type == 'p' || type == 'f') &&
		       strieq(field->data, "newsgroups"))
		strncpy(dest, content->data, sizeof(dest));
	      else if (strieq(field->data, "to"))
		strncpy(dest, content->data, sizeof(dest));
	      else {
		buf_cat(txt, field);
		buf_appends(txt, ": ");
		buf_cat(txt, content);
		buf_nl(txt);
		hdr = 1;
	      }
	    }
	    if (hdr)
	      buf_nl(txt);
	    buf_rest(txt, tmp);
	  } else
	    buf_read(txt, f);
	  fclose(f);
	  unlink(path);
	  strncat(path, "~", PATHMAX);
	  unlink(path);
#ifndef USE_NCURSES
	  {
	    char line[4];

	    fprintf(stderr, "Send message [y/n]? ");
	    scanf("%3s", line);
	    if (!strleft(line, "y"))
	      goto quit;
	  }
#else
	  goto redraw;
	}
	break;
      case 'm':
	if (txt->length == 0)
	  beep();
	else if (dest[0] == '\0') {
	  mix_status("No destination given.");
	  goto redraw;
	} else {
	  mix_status("Creating message...");
#endif
	  buf_reset(msg);

	  if (type == 'p' || type == 'f')
	    buf_appends(msg, "Newsgroups: ");
	  else
	    buf_appends(msg, "To: ");
	  buf_appends(msg, dest);
	  buf_nl(msg);
	  buf_appends(msg, "Subject: ");
	  if (subject[0] == '\0')
	    buf_appends(msg, "(no subject)");
	  else
	    buf_appends(msg, subject);
	  buf_nl(msg);
	  if (!hdr)
	    buf_nl(msg);
	  buf_cat(msg, txt);
#ifdef USE_PGP
	  {
	    BUFFER *p, *keytxt;

	    p = buf_new();
	    keytxt = buf_new();
	    if (streq(thisnym, ANON))
	      sign = 0, key = 0;
	    if (sign || (key && !strileft(thisnym, NONANON)))
	      user_pass(p);
	    if (key) {
	      BUFFER *uid;

	      uid = buf_new();
	      buf_appendc(uid, '<');
	      buf_appends(uid, strleft(thisnym, NONANON) ? ADDRESS : thisnym);
	      buf_appendc(uid, '>');
	      pgp_pubkeycert(uid, strleft(thisnym, NONANON) ?
			     PGPSECRING : NYMSECRING, p, keytxt, 3);
	      buf_free(uid);
	    }
	    if (encrypt && keytxt->length > 0) {
	      buf_nl(msg);
	      buf_cat(msg, keytxt);
	      buf_clear(keytxt);
	    }
	    if (encrypt || sign) {
	      if (pgp_mailenc((encrypt ? PGP_ENCRYPT : 0)
			      | (sign ? PGP_SIGN : 0) | PGP_TEXT
			      | (strleft(thisnym, NONANON) ? 0 : PGP_REMAIL),
			      msg, strleft(thisnym, NONANON) ?
			      ADDRESS : thisnym, p, PGPPUBRING,
			      strleft(thisnym, NONANON) ?
			      PGPSECRING : NYMSECRING) == -1) {
		/*mix_status("Encryption failed: missing key!");*/
#ifdef USE_NCURSES
		beep();
		goto redraw;
#endif
	      }
	    }
	    if (keytxt->length > 0) {
	      buf_nl(msg);
	      buf_cat(msg, keytxt);
	    }
	    buf_free(p);
	  }
#endif

	  if (strleft(thisnym, NONANON)) {
	    FILE *f = NULL;

	    if (type == 'p' || type == 'f') {
	      if (strchr(NEWS, '@')) {
		/*  NOT_IMPLEMENTED; */
	      } else
		f = openpipe(NEWS);
	    } else {
	      if (NAME[0]) {
		buf_sets(tmp, NAME);
		buf_appends(tmp, " <");
		buf_appends(tmp, ADDRESS);
		buf_appends(tmp, ">");
	      } else
		buf_sets(tmp, ADDRESS);
	      mail_encode(msg);
	      if (sendmail(msg, tmp->data, NULL) != 0) {
#ifdef USE_NCURSES
		clear();
#endif
		mix_status("Error sending message.");
#ifdef USE_NCURSES
		goto redraw;
#else
		goto quit;
#endif
	      }
	    }
#ifdef USE_NCURSES
	    clear();
#endif
	    mix_status("Message sent non-anonymously.");
	    goto quit;
	  } else {
#ifdef USE_PGP
	    if (!streq(thisnym, ANON)) {
	      if (nym_encrypt(msg, thisnym, (type == 'p' || type == 'f') ?
			      MSG_POST : MSG_MAIL) == 0)
		type = 'm';
	    }
#endif
	    err = mix_encrypt((type == 'p' || type == 'f') ?
			      MSG_POST : MSG_MAIL,
			      msg, chain, numcopies, chainlist);
	    if (err == 0) {
#ifdef USE_NCURSES
	      clear();
#endif
	      for (n = 0; buf_getline(chainlist, tmp) == 0; n++) ;
	      if (n > 1)
		mix_status("Done. (%d packets)", n);
	      else
		mix_status("Chain: %s", chainlist->data);
	      goto quit;
	    } else {
#ifdef USE_NCURSES
	      beep();
#endif
	      if (chainlist->length)
		mix_status("%s", chainlist->data);
	      else
		mix_status("Failed!");
	    }
	  }
	}
#ifdef USE_NCURSES
	break;
      case 'q':
      case 'Q':
	clear();
	goto quit;
#ifdef USE_PGP
      case 'p':
	if (!streq(thisnym, ANON))
	  sign = !sign;
	break;
      case 'y':
	encrypt = !encrypt;
	break;
      case 'k':
	if (!streq(thisnym, ANON))
	  key = !key;
	break;
#endif
      default:
	beep();
      }
    }
  }
#endif
quit:
  buf_free(cc);
  buf_free(cite);
  buf_free(msg);
  buf_free(txt);
  buf_free(field);
  buf_free(content);
  buf_free(chainlist);
  buf_free(tmp);
  buf_free(tmp2);
}
